//+------------------------------------------------------------------+
//|                                                testindicator.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1 Gray
#property indicator_color2 DarkGreen
#property indicator_color3 Red
//---- indicator parameters
extern int mxmnwindow = 10;
extern bool onlycurrentsymbol = true;

//---- buffers
double ExtMapBuffer[];
double MaxBuffer[];
double MinBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexShift(0, 1);
   
   SetIndexStyle(1,DRAW_LINE,2);
   SetIndexBuffer(1,MaxBuffer);

   SetIndexStyle(2,DRAW_LINE,2);
   SetIndexBuffer(2,MinBuffer);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i=0, j=0, accTotal=OrdersHistoryTotal(), currentTotal = OrdersTotal();

   double AE = 0;

   ExtMapBuffer[0] = AccountEquity();
   ExtMapBuffer[1] = AccountEquity();

   if (onlycurrentsymbol)
   {
     for(i=0; i<accTotal; i++)
     {
         if (!OrderSelect(accTotal-i-1,SELECT_BY_POS,MODE_HISTORY)) continue;
         if (OrderSymbol() != Symbol()) continue;
         if (OrderType() == 6) continue;
         AE += (OrderProfit() + OrderSwap());
     }
     ExtMapBuffer[0] = AE;
     ExtMapBuffer[1] = AE;
   }

  j++;
   
  for(i=0; i<currentTotal; i++)
    {
     if (OrderSelect(currentTotal-i-1,SELECT_BY_POS,MODE_TRADES))
     {
         if ((OrderSymbol() != Symbol()) && onlycurrentsymbol) continue;
         ExtMapBuffer[1] = ExtMapBuffer[1] - OrderProfit();
     }
    }

  for(i=0; i<accTotal; i++)
    {
      if (OrderSelect(accTotal-i-1,SELECT_BY_POS,MODE_HISTORY))
      {
         if ((OrderSymbol() != Symbol()) && onlycurrentsymbol) continue;
         ExtMapBuffer[j+1] = ExtMapBuffer[j] - OrderProfit();
         j++;
      }
    }

   if (j> mxmnwindow)
     for(i=0;i < j-mxmnwindow; i++)
      {
         MaxBuffer[i] =ExtMapBuffer [ArrayMaximum(ExtMapBuffer, mxmnwindow, i+1)];
         MinBuffer[i] =ExtMapBuffer [ArrayMinimum(ExtMapBuffer, mxmnwindow, i+1)];
      } 

   return(0);
  }
//+------------------------------------------------------------------+